SystemOrganization addCategory: #CS528su13!
SystemOrganization addCategory: #'CS528su13-HW2'!
SystemOrganization addCategory: #'CS528su13-HW3'!
SystemOrganization addCategory: #'CS528su13-Payroll'!
SystemOrganization addCategory: #'CS528su13-ValueWithHistory'!

TestCase subclass: #EmployeeTestCase
	instanceVariableNames: 'susan day1 normalMonth aLittleOvertime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!EmployeeTestCase methodsFor: 'Running' stamp: 'dd 1/11/2005 19:36'!
setUp
	day1 := Date 
				newDay: 11
				month: 7
				year: 2001.
	susan := Employee new named: 'Susan'.
	normalMonth := #(#(40 0) #(40 0) #(40 0) #(40 0)).
	aLittleOvertime := #(#(40 0) #(50 0) #(40 0) #(40 0))
			! !

!EmployeeTestCase methodsFor: 'Testing' stamp: 'HenryDuwe 6/20/2013 17:33'!
testChangeSalary
	susan changeSalaryFor: day1 to: 20.
	self assert: ((susan salaryAt: day1) = 20).
	day1 addDays: 7.
	susan changeSalaryFor: day1 to: 25.
	self assert: (susan salaryAt: day1) = 25.
			! !

TestCase subclass: #HW2TestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-HW2'!

!HW2TestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 10:16'!
testAsLowerCase1
	|orig final|
	orig := 'ALL CAPITALS!!'.
	final := HW2 asLowerCase: orig.
	self assert: (final asSymbol == 'all capitals!!' asSymbol).
! !

!HW2TestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 10:17'!
testAsLowerCase2
	|orig final|
	orig := 'no capitals!!'.
	final := HW2 asLowerCase: orig.
	self assert: (final asSymbol == 'no capitals!!' asSymbol).
! !

!HW2TestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 13:58'!
testCapitalLetters1
	|orig final|
	orig := 'This Is IT!!'.
	final := HW2 capitalLetters: orig.
	self assert: (final includes: $T).
	self assert: (final includes:  $I).
	self assert: (final size == 2).
	self assert: ((final includes: $S )not).! !

!HW2TestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 10:15'!
testCapitalLetters2
	|orig final|
	orig := 'no capitals!!'.
	final := HW2 capitalLetters: orig.
	self assert: (final isEmpty).
! !

!HW2TestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 10:07'!
testCapitals1
	|orig final|
	orig := 'This Is It!!'.
	final := HW2 capitals: orig.
	self assert: final asSymbol == ('TII' asSymbol)! !

!HW2TestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 10:07'!
testCapitals2
	|orig final|
	orig := 'this is it!!'.
	final := HW2 capitals: orig.
	self assert: final asSymbol == ('' asSymbol)! !

!HW2TestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 10:19'!
testEncode1
	|orig final|
	orig := 'Plain Text!!'.
	final := HW2 encode: orig.
	self assert: (final asSymbol == 'Qmbjo Ufyu!!' asSymbol).
! !

!HW2TestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 10:20'!
testEncode2
	|orig final|
	orig := 'I am sleepy...zzzZZZZZ'.
	final := HW2 encode: orig.
	self assert: (final asSymbol == 'J bn tmffqz...aaaAAAAA' asSymbol).
! !

!HW2TestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 10:09'!
testReverse1
	|str revStr|
	str := 'ABCDEFG'.
	revStr := HW2 reverse: str.
	self assert: revStr asSymbol == ('GFEDCBA' asSymbol).! !

!HW2TestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 10:57'!
testReverse2
	|str revStr|
	str := #(1 2 5 6 8).
	revStr := HW2 reverse: str.
	self assert: revStr = #(8 6 5 2 1).! !

!HW2TestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 11:47'!
testWordValue1
	|orig final|
	orig := 'hexapuma'.
	final := HW2 wordValue: orig.
	self assert: (final == (8+5+24+1+16+21+13+1)).
! !

!HW2TestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 10:25'!
testWordValue2
	|orig final|
	orig := 'ArtIChoke'.
	final := HW2 wordValue: orig.
	self assert: (final == (1+18+20+9+3+8+15+11+5)).! !

TestCase subclass: #NumberWithUnitsTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-HW3'!

!NumberWithUnitsTestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/12/2013 16:08'!
testAddition
	|num1 num2 num3|
	num1 := 3 sec.
	num2 := 5 sec.
   num3 := num1 + num2.
	self assert: num3 class = NumberWithUnits.
	"Bad test because its really testing implementation..."
	Transcript show: num3.
	self assert: (num3 value = 8 & num3 units = (Units newNumeratorUnit: #seconds)).
	! !

!NumberWithUnitsTestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/12/2013 16:09'!
testDivision
	|num1 num2 num3|
	num1 := 3 sec.
	num2 := 5 sec.
   num3 := num1 / num2.
	self assert: num3 class = NumberWithUnits.
	"Bad test because its really testing implementation..."
	Transcript show: num3.
	self assert: (num3 value = (3/5) & num3 units = ((Units newNumeratorUnit: #seconds) subtraction: #seconds)).
	! !

!NumberWithUnitsTestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/12/2013 16:10'!
testMultiplication
	|num1 num2 num3|
	num1 := 3 sec.
	num2 := 5 sec.
   num3 := num1 * num2.
	self assert: num3 class = NumberWithUnits.
	"Bad test because its really testing implementation..."
	Transcript show: num3.
	self assert: (num3 value = 15 & num3 units = ((Units newNumeratorUnit: #seconds) addition: #seconds)).! !

!NumberWithUnitsTestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/12/2013 16:16'!
testNumberAll
	|num1 num2 num3 num4 num5|
	num1 := 3 sec.
	num2 := 2 elephant.
	num3 := 5 meter.
	num4 := num2 * num3/num1.
	self assert: num4  class = NumberWithUnits.
	"Bad test because its really testing implementation..."
	Transcript show: num4 .
	self assert: (num4  value = (10/3)) & num4 units = ((((Units newNumeratorUnit: #elephants) addition: #meters) subtraction: #seconds)).
	! !

!NumberWithUnitsTestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/12/2013 16:11'!
testNumberSec
	|num|
	num := 3 sec.
	self assert: num class = NumberWithUnits.
	"Bad test because its really testing implementation..."
	Transcript show: num.
	self assert: (num value = 3 & num units = (Units newNumeratorUnit: #seconds)).
	! !

!NumberWithUnitsTestCase methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/12/2013 16:11'!
testSubtraction
	|num1 num2 num3|
	num1 := 3 sec.
	num2 := 5 sec.
   num3 := num1 - num2.
	self assert: num3 class = NumberWithUnits.
	"Bad test because its really testing implementation..."
	Transcript show: num3.
	self assert: (num3 value = -2 & num3 units = (Units newNumeratorUnit: #seconds)).
	! !

TestCase subclass: #PayrollSystemTestCase
	instanceVariableNames: 'myPayroll day1 susan george normalMonth aLittleOvertime today aMissedTimeCard aLateTimeCard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!PayrollSystemTestCase methodsFor: 'private' stamp: 'HenryDuwe 6/20/2013 15:50'!
postTimeCards: collection to: anEmployee 
	| timecardDay |
	timecardDay := day1.
	collection do: 
			[:each | 
			(each size = 2)
			ifTrue: 
				[anEmployee 
					postTimeCardFor: timecardDay
					hoursWorked: each first
					vacation: each last].
			timecardDay := timecardDay addDays: 7]
			! !

!PayrollSystemTestCase methodsFor: 'Running' stamp: 'HenryDuwe 6/20/2013 15:42'!
setUp
	myPayroll := PayrollSystem new name: 'ACME'.
	day1 := Date newDay: 11 month: 7 year: 2001. 
	susan := Employee new named: 'Susan'.
	susan changeSalaryFor: day1 to: 20.
	george := Employee new named: 'George'.
	george changeSalaryFor: day1 to: 12.
	normalMonth := #(#(40 0) #(40 0) #(40 0) #(40 0)).
	aLittleOvertime := #(#(40 0) #(50 0) #(40 0) #(40 0)).
	aMissedTimeCard  := #(#(40 0) #() #(40 0) #(40 0)).
	aLateTimeCard := #(#() #(40 0) #() #()).
	today := day1 addDays: 28.
			! !

!PayrollSystemTestCase methodsFor: 'Testing' stamp: 'HenryDuwe 6/5/2013 16:58'!
testAddEmployee
	myPayroll addEmployee: susan.
	self assert: (myPayroll employeeNames includes: 'Susan').
	myPayroll addEmployee: george.
	self assert: (myPayroll employeeNamed: 'Susan') = susan
		! !

!PayrollSystemTestCase methodsFor: 'Testing' stamp: 'HenryDuwe 6/20/2013 15:37'!
testEarnings
	myPayroll
		addEmployee: susan;
		addEmployee: george.
	self postTimeCards: normalMonth to: susan.
	self postTimeCards: aLittleOvertime to: george.
	self assert: ((susan earnedAt: today) = 3200).
	self assert: ((george earnedAt: today) = 2100).
			! !

!PayrollSystemTestCase methodsFor: 'Testing' stamp: 'Biplab Deka 6/19/2013 14:15'!
testFileWrite
	| aFile aPS|
	aFile := 'test.txt'.
	myPayroll addEmployee: susan.
	myPayroll addEmployee: george.
	
	myPayroll writeToFile: aFile.
	
	
	aPS := PayrollSystem readFromFile: aFile.
	
	Transcript show: (myPayroll name).
	Transcript show: (Character cr).
	Transcript show: (aPS name).
	Transcript show: (Character cr).
	
	Transcript show: (myPayroll employeeNames size).
	Transcript show: (Character cr).
	Transcript show: (aPS employeeNames size ).
	Transcript show: (Character cr).
	
	self assert: (myPayroll name = aPS name).
	self assert: (myPayroll employeeNames = aPS employeeNames).
	
	! !

!PayrollSystemTestCase methodsFor: 'Testing' stamp: 'HenryDuwe 6/20/2013 15:59'!
testLateTimeCard
	myPayroll
		addEmployee: susan;
		addEmployee: george.
	self postTimeCards: aMissedTimeCard to: george.
	george changeSalaryFor: (day1 addDays: 21) to: 100.
	self postTimeCards: aLateTimeCard to: george.
	self assert: ((george earnedAt: today) = 1920).
			! !

!PayrollSystemTestCase methodsFor: 'Testing' stamp: 'HenryDuwe 6/20/2013 16:56'!
testPrintSalaryHistory
	|aStream|
	myPayroll
		addEmployee: susan;
		addEmployee: george.
	self postTimeCards: aMissedTimeCard to: george.
	george changeSalaryFor: (day1 addDays: 21) to: 100.
	self postTimeCards: aLateTimeCard to: george.
	george changeSalaryFor: (day1 addDays: 21) to: 130.
	george changeSalaryFor: (day1 addDays: 42) to: 150.
	george changeSalaryFor: (day1 addDays: 63) to: 110.
	george changeSalaryFor: (day1 addDays: 84) to: 123.
	
	aStream := ReadWriteStream on: ''.
	george salaryHistoryOn: aStream.
	Transcript show: aStream contents.
			! !

!PayrollSystemTestCase methodsFor: 'Testing' stamp: 'HenryDuwe 6/20/2013 17:40'!
testTakeHomePay
	|jdoe day0 day2 day3 dayp pay1|
	day0 := Date newDay: 1 month: 5 year: 1999.
	jdoe := Employee new named: 'John Doe'.
	myPayroll addEmployee: jdoe.
	jdoe changeSalaryFor: day0  to: 20.
	jdoe changeInsuranceFor: day0 to: 200. 
	
	day2 := Date newDay: 5 month: 5 year: 1999.
	jdoe postTimeCardFor: day2 hoursWorked: 40 vacation: 0.
	
	day3 := Date newDay: 12 month: 5 year: 1999.
	jdoe postTimeCardFor: day3 hoursWorked: 40 vacation: 0.
	
	"self assert: jdoe earned = 1600."
	
	dayp := Date newDay: 15 month: 5 year: 1999.
	pay1 := jdoe makePaycheckAt: dayp.
	"Transcript show: pay1 amountPaid."
	self assert: pay1 amountPaid = 988.8.
	! !

TestCase subclass: #SortedSequenceTestCase
	instanceVariableNames: 'sequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!SortedSequenceTestCase methodsFor: 'Running' stamp: ''!
setUp
	sequence := SortedSequence new.
	sequence add: 1; add: 80; add: 500; add: 501
			! !

!SortedSequenceTestCase methodsFor: 'Testing' stamp: ''!
testIndex
	"(SortedSequenceTestCase selector: #testIndex) run"

	self assert: (sequence indexOfStartOfIntervalContaining: 1) = 1.
	self assert: (sequence indexOfStartOfIntervalContaining: 79) = 1.
	self assert: (sequence indexOfStartOfIntervalContaining: 80) = 2.
	self assert: (sequence indexOfStartOfIntervalContaining: 501)	= 4
			! !

TestCase subclass: #ValueWithHistoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-ValueWithHistory'!

!ValueWithHistoryTest methodsFor: 'testing' stamp: 'm3r 6/27/2008 02:15'!
test
	| history day3 day2 day1 day4 |
	day3 := '12/12/2007' asDate.
	day2 := day3 subtractDays: 3.
	day1 := day2 subtractDays: 3.
	day4 :=  day3 addDays: 4.
	(history := ValueWithHistory new) starting: day3 become: 3.
	history starting: day1 become: 1.
	self should: [(history at: day2) = 1].
	history at: day2 add: 1.
	self should: [(history at: day3) = 4].
	history at: day4 add: 2.
	self should: [(history at: day4) = 6].
! !

!Number methodsFor: '*CS528su13-HW3' stamp: 'HenryDuwe 6/12/2013 16:13'!
elephant
	^ NumberWithUnits newValue: self units: (Units newNumeratorUnit: #elephants).! !

!Number methodsFor: '*CS528su13-HW3' stamp: 'HenryDuwe 6/12/2013 16:12'!
meter
	^ NumberWithUnits newValue: self units: (Units newNumeratorUnit: #meters).! !

!Number methodsFor: '*CS528su13-HW3' stamp: 'HenryDuwe 6/12/2013 15:58'!
sec
	^ NumberWithUnits newValue: self units: (Units newNumeratorUnit: #seconds).! !

Number subclass: #NumberWithUnits
	instanceVariableNames: 'units value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-HW3'!

!NumberWithUnits class methodsFor: 'instance creation' stamp: 'HenryDuwe 6/12/2013 15:58'!
newValue: aValue units: aUnit
	^ self new setValue: aValue units: aUnit.! !

!NumberWithUnits methodsFor: 'arithmetic' stamp: 'HenryDuwe 6/12/2013 16:12'!
* aNumberWithUnits
	"
	Transcript show: 'Blah'.
	Transcript show: units*units.
	Transcript show: aNumberWithUnits units."
	^ NumberWithUnits newValue: ((self value) * (aNumberWithUnits value)) units: ((self units) * (aNumberWithUnits units)).! !

!NumberWithUnits methodsFor: 'arithmetic' stamp: 'HenryDuwe 6/12/2013 15:52'!
+ aNumberWithUnits
	(aNumberWithUnits units = units) 
						ifFalse:[^nil] 
						ifTrue:[^ NumberWithUnits newValue: (self value + aNumberWithUnits value) units: units].
	! !

!NumberWithUnits methodsFor: 'arithmetic' stamp: 'HenryDuwe 6/12/2013 13:02'!
- aNumberWithUnits
	^ self + aNumberWithUnits negated.! !

!NumberWithUnits methodsFor: 'arithmetic' stamp: 'HenryDuwe 6/12/2013 14:13'!
/ aNumberWithUnits
	^ NumberWithUnits newValue: (self value / (aNumberWithUnits value)) units: (self units / (aNumberWithUnits units)).! !

!NumberWithUnits methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/12/2013 13:40'!
negated
	^ NumberWithUnits newValue: self value negated units: self units.! !

!NumberWithUnits methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/12/2013 15:11'!
printOn: aStream
	self printOn: aStream base: 10.! !

!NumberWithUnits methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/12/2013 15:07'!
printOn: aStream base: base
	aStream nextPut: $(.
	value printOn: aStream base: base.
	aStream nextPut: Character space.
	units printOn: aStream.
	aStream nextPut: $).! !

!NumberWithUnits methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/12/2013 12:58'!
setValue: aValue units: aUnits
	value := aValue.
	units := aUnits.! !

!NumberWithUnits methodsFor: 'accessing' stamp: 'HenryDuwe 6/12/2013 15:59'!
units
	^units.! !

!NumberWithUnits methodsFor: 'accessing' stamp: 'HenryDuwe 6/12/2013 14:57'!
value
	^value.! !

SortedCollection variableSubclass: #SortedSequence
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!SortedSequence commentStamp: '<historical>' prior: 0!
I add one method to SortedCollection.  It would be just as easy to add the method
directly to the class instead of making a subclass, but this makes it easier to see
the new method.

The method is indexOfStartOfIntervalContaining: anElement
It returns the index of anElement or, if it is not present, the index of the
largest element smaller than it.  It is useful when you want to have a
table that is sorted by keys and you want to look up in the table to
find the nearest match to a key.!

!SortedSequence methodsFor: 'accessing' stamp: ''!
indexOfStartOfIntervalContaining: anElement 
	"Return the index of anElement or, if it is not present, of the index of the
	largest element smaller than it."

	self isEmpty ifTrue: [^0].
	^(self indexForInserting: anElement) - firstIndex
			! !

Object subclass: #Employee
	instanceVariableNames: 'name transactions salary earned paid withholding accruedVacation taxRule insuranceWithholding insurancePremium insurance'
	classVariableNames: 'HeadTaxRate MarriedSeparateTaxRate MarriedTaxRate SingleTaxRate'
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!Employee commentStamp: '<historical>' prior: 0!
I represent an employee in a payroll system.  Thus, I keep track of the number of hours worked,
the wages paid, the vacation accrued, the taxes withheld, and so on.  My values change only
when transactions are posted to me.  Transactions are subclasses of EmployeeTransaction.

Variables
	name 				<String>
	transactions 			<Collection of Transactions, sorted by date>
	salary 				<ValueWithHistory>
	earned  				<ValueWithHistory>
	paid  				<ValueWithHistory>
	withholding  			<ValueWithHistory>
	accruedVacation  	<ValueWithHistory>
	taxRule 				<TaxRule>!

!Employee class methodsFor: 'class initialization' stamp: ''!
initialize
	"Employee initialize"
	SingleTaxRate := TaxRule new.
	SingleTaxRate
		breakPoint: 0 rate: 0.15;
		breakPoint: 22750 rate: 0.28;
		breakPoint: 55100 rate: 0.31;
		breakPoint: 115000 rate: 0.36;
		breakPoint: 250000 rate: 0.396.

	MarriedTaxRate := TaxRule new.
	MarriedTaxRate
		breakPoint: 0 rate: 0.15;
		breakPoint: 38000 rate: 0.28;
		breakPoint: 91850 rate: 0.31;
		breakPoint: 140000 rate: 0.36;
		breakPoint: 250000 rate: 0.396.

	MarriedSeparateTaxRate := TaxRule new.
	MarriedSeparateTaxRate
		breakPoint: 0 rate: 0.15;
		breakPoint: 19500 rate: 0.28;
		breakPoint: 45925 rate: 0.31;
		breakPoint: 70000 rate: 0.36;
		breakPoint: 125000 rate: 0.396.

	HeadTaxRate := TaxRule new.
	HeadTaxRate
		breakPoint: 0 rate: 0.15;
		breakPoint: 30500 rate: 0.28;
		breakPoint: 78700 rate: 0.31;
		breakPoint: 127500 rate: 0.36;
		breakPoint: 250000 rate: 0.396.
			! !

!Employee methodsFor: 'actions' stamp: 'HenryDuwe 6/20/2013 17:09'!
changeInsuranceFor: aDate to: dollarPerPaycheck 
	self postTransaction: (InsuranceChange 
			newDate: aDate
			employee: self
			premium: dollarPerPaycheck)
			! !

!Employee methodsFor: 'actions' stamp: 'HenryDuwe 6/5/2013 13:49'!
changeSalaryFor: aDate to: dollarPerHour 
	self postTransaction: (SalaryChange 
			newDate: aDate
			employee: self
			salary: dollarPerHour)
			! !

!Employee methodsFor: 'accessing' stamp: 'HenryDuwe 6/20/2013 15:02'!
earnedAt: aDate
	^earned at: aDate.
			! !

!Employee methodsFor: 'private' stamp: ''!
federalTaxesOn: money assumingTotalIs: estimatedEarnings
	^money * (taxRule rateFor: estimatedEarnings)
			! !

!Employee methodsFor: 'posting' stamp: 'HenryDuwe 6/20/2013 15:08'!
incrementEarned: anAmount at: aDate
	earned at: aDate add: anAmount.
			! !

!Employee methodsFor: 'posting' stamp: 'HenryDuwe 6/20/2013 17:15'!
incrementInsuranceWithholding: anAmount at: aDate
	insuranceWithholding at: aDate add: anAmount.
			! !

!Employee methodsFor: 'posting' stamp: 'HenryDuwe 6/20/2013 15:08'!
incrementPaid: anAmount at: aDate
	paid at: aDate add: anAmount.
			! !

!Employee methodsFor: 'posting' stamp: 'HenryDuwe 6/20/2013 15:09'!
incrementWithholding: anAmount at: aDate
	withholding at: aDate add: anAmount.
			! !

!Employee methodsFor: 'posting' stamp: 'HenryDuwe 6/20/2013 17:15'!
insurance: anAmount at: aDate
	insurance starting: aDate become: anAmount.
			! !

!Employee methodsFor: 'accessing' stamp: 'HenryDuwe 6/20/2013 17:25'!
insuranceAt: aDate
	^insurance at:aDate.
			! !

!Employee methodsFor: 'actions' stamp: 'HenryDuwe 6/20/2013 17:32'!
makePaycheckAt: aDate 
	"Create a paycheck for the amount owed to the employee. It hasn't 
	been posted."

	| amountPaid amountWithheld amountInsurance |
	amountPaid := (earned at: aDate) - (paid at: aDate) - (withholding at: aDate) - (insuranceWithholding at: aDate).
	amountWithheld := self taxesOn: amountPaid at: aDate.
	amountInsurance := self insuranceAt: aDate.
	amountPaid := amountPaid - amountWithheld - amountInsurance.

	^Paycheck new
		date: aDate
		employee: self
		paid: amountPaid
		withheld: amountWithheld
		insuranceWithheld: amountInsurance
		totalPaid: (paid at: aDate) + amountPaid
		totalWithheld: (withholding at: aDate) + amountWithheld
		totalInsuranceWithheld: (insuranceWithholding at: aDate) + amountInsurance.
			! !

!Employee methodsFor: 'accessing' stamp: ''!
name
	^name
			! !

!Employee methodsFor: 'initialize-release' stamp: 'HenryDuwe 6/20/2013 17:16'!
named: aString
	name := aString.
	transactions := OrderedCollection new.
	salary := ValueWithHistory zero.
	earned := ValueWithHistory zero.
	paid := ValueWithHistory zero.
	withholding := ValueWithHistory zero.
	insuranceWithholding := ValueWithHistory zero.
	accruedVacation := ValueWithHistory zero.
	insurance := ValueWithHistory zero.
	taxRule := SingleTaxRate
			! !

!Employee methodsFor: 'accessing' stamp: 'HenryDuwe 6/20/2013 15:12'!
paidAt: aDate 
	^paid at: aDate.
			! !

!Employee methodsFor: 'actions' stamp: ''!
postTimeCardFor: aDate hoursWorked: hoursW vacation: hoursV 
	self postTransaction: (Timecard new
			date: aDate
			employee: self
			worked: hoursW
			vacation: hoursV)
			! !

!Employee methodsFor: 'posting' stamp: ''!
postTransaction: aTransaction
	"Public interface to record and process (i.e. post) a transaction."
	aTransaction postTo: self.
	transactions add: aTransaction
			! !

!Employee methodsFor: 'accessing' stamp: 'HenryDuwe 6/20/2013 15:13'!
salary: anAmount at: aDate
	salary starting: aDate become: anAmount.
			! !

!Employee methodsFor: 'accessing' stamp: 'HenryDuwe 6/20/2013 15:13'!
salaryAt: aDate
	^salary at:aDate.
			! !

!Employee methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/20/2013 15:21'!
salaryHistoryOn: aStream
	salary printOn: aStream.! !

!Employee methodsFor: 'private' stamp: 'HenryDuwe 6/20/2013 15:36'!
taxesOn: money at: date 
	"Return the taxes to be withheld from the money earned."
	"This is just a guess - I didn't look up the tax rules."

	| socialSecurity federalTaxes stateTaxes estimatedEarnings |
	socialSecurity := (0 max: (money min: 60600 - (earned at: date)))
				* 0.077.
	estimatedEarnings := (earned at: date) + money * date day / date daysInYear.
	federalTaxes := self federalTaxesOn: money assumingTotalIs: estimatedEarnings.
	stateTaxes := money * 0.03.	"Illinois has a flat tax."
	^socialSecurity + federalTaxes + stateTaxes
			! !

Object subclass: #EmployeeTransaction
	instanceVariableNames: 'date employee'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!EmployeeTransaction commentStamp: '<historical>' prior: 0!
I'm an abstract class of transactions that can be posted to an Employee.

My most important method is postTo:, which is implemented by subclasses
to send a message to the Employee to post the transaction.  The Employee
has all the information, so it has to be the one to implement posting, but the
postTo: method implements a standard interface so that clients of the
payroll system can always post a transaction by sending the postTransaction:
message to an Employee.

Variables
	date		<Date>   Date at which transaction occured.
	employee	<Employee>

!

!EmployeeTransaction methodsFor: 'accessing' stamp: ''!
date
	^date
			! !

!EmployeeTransaction methodsFor: 'posting' stamp: ''!
post
	employee postTransaction: self
			! !

!EmployeeTransaction methodsFor: 'posting' stamp: ''!
postTo: anEmployee
	"double dispatching"
	self subclassResponsibility
			! !

EmployeeTransaction subclass: #InsuranceChange
	instanceVariableNames: 'newPremium'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!InsuranceChange class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/20/2013 17:39'!
newDate: aDate employee: anEmployee premium: dollarPerPaycheck
	^self new date: aDate employee: anEmployee premium: dollarPerPaycheck. ! !

!InsuranceChange methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/20/2013 17:11'!
date: aDate employee: anEmployee premium: dollarPerPaycheck
	date := aDate.
	employee := anEmployee.
	newPremium := dollarPerPaycheck.! !

!InsuranceChange methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/20/2013 17:13'!
newPremium
	^newPremium.! !

!InsuranceChange methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/20/2013 17:14'!
postTo: anEmployee
	anEmployee insurance: newPremium at: date.
			! !

EmployeeTransaction subclass: #Paycheck
	instanceVariableNames: 'amountPaid taxes insurance totalPaid totalTaxes totalInsurance'
	classVariableNames: 'AmountFormat DateFormat'
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!Paycheck commentStamp: '<historical>' prior: 0!
Transaction representing a payment to an employee.!

!Paycheck class methodsFor: 'class initialization' stamp: 'dd 12/23/2004 18:15'!
initialize
	"Paycheck initialize"

	"AmountFormat := NumberPrintPolicy newFor: #usCurrency.
	DateFormat := TimestampPrintPolicy newFor: #us"
			! !

!Paycheck methodsFor: 'accessing' stamp: ''!
amountPaid
	^amountPaid
			! !

!Paycheck methodsFor: 'initialize-release' stamp: 'HenryDuwe 6/20/2013 17:21'!
date: aDate employee: anEmployee paid: amount1 withheld: amount2 insuranceWithheld: amount5 totalPaid: amount3 totalWithheld: amount4 totalInsuranceWithheld: amount6
	date := aDate.
	employee := anEmployee.
	amountPaid := amount1.
	taxes := amount2.
	insurance := amount5.
	totalPaid := amount3.
	totalTaxes := amount4.
	totalInsurance := amount6.
			! !

!Paycheck methodsFor: 'accessing' stamp: 'HenryDuwe 6/20/2013 17:17'!
insurance
	^insurance.
			! !

!Paycheck methodsFor: 'posting' stamp: 'HenryDuwe 6/20/2013 17:19'!
postTo: anEmployee
	anEmployee incrementPaid: amountPaid at: date.
	anEmployee incrementWithholding: taxes at: date.
	anEmployee incrementInsuranceWithholding: insurance at: date. 
			! !

!Paycheck methodsFor: 'printing' stamp: 'HenryDuwe 6/20/2013 17:19'!
printOnCheckStream: aStream
	"This method is supposed to print information on a check that is on the printer, and
	aStream is the printer.  Unfortunately, the whole method is bogus, because we don't
	know what the printer or the check are like.  I'm assuming that the check has two-parts.
	One is the actual check, and we need to print the employee's name and the amount.
	The second is the check stub, which will say how much is being paid and how much
 	is being withheld. I'm also assuming that the check is preprinted with the name of the
	company, and everything else that is usual for a check."

	aStream cr; cr.
	aStream next: 40 put: (Character space).
	"DateFormat print: date on: aStream."
	date printOn: aStream.
	aStream cr.
	aStream nextPutAll: ((String new: 40 withAll: Character space) copyReplaceFrom: 1 to: employee name size with: employee name).
	"AmountFormat print: amountPaid on: aStream."
	amountPaid printOn: aStream.
	aStream cr; cr; cr; cr.
	aStream nextPutAll: 'this month  '.
	"AmountFormat print: amountPaid on: aStream.
	AmountFormat print: taxes on: aStream."
	aStream nextPutAll: ' amountPaid: $'.
	amountPaid printOn: aStream.
	aStream nextPutAll: ' taxes: $'.
	taxes printOn: aStream.
	aStream nextPutAll: ' insurance: $'.
	insurance printOn: aStream.
	aStream cr.
	aStream nextPutAll: 'year to date '.
	"AmountFormat print: totalPaid on: aStream.
	AmountFormat print: totalTaxes on: aStream."
	aStream nextPutAll: ' amountPaid: $'.
	totalPaid printOn: aStream.
	aStream nextPutAll: ' taxes: $'.
	totalTaxes printOn: aStream.
	aStream nextPutAll: ' insurance: $'.
	totalInsurance printOn: aStream.
	aStream cr; cr.
			! !

!Paycheck methodsFor: 'accessing' stamp: ''!
taxes
	^taxes
			! !

EmployeeTransaction subclass: #SalaryChange
	instanceVariableNames: 'newSalary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!SalaryChange commentStamp: '<historical>' prior: 0!
Transaction representing a change in salary, usually a raise.!

!SalaryChange class methodsFor: 'instance creation' stamp: 'HenryDuwe 6/5/2013 13:51'!
newDate: aDate employee: anEmployee salary: dollarPerHour
	^self new date: aDate employee: anEmployee salary: dollarPerHour. ! !

!SalaryChange methodsFor: 'initialize-release' stamp: ''!
date: aDate employee: anEmployee salary: dollarPerHour
	date := aDate.
	employee := anEmployee.
	newSalary := dollarPerHour
			! !

!SalaryChange methodsFor: 'accessing' stamp: ''!
newSalary
	^newSalary
			! !

!SalaryChange methodsFor: 'posting' stamp: 'HenryDuwe 6/20/2013 15:29'!
postTo: anEmployee
	anEmployee salary: newSalary at: date.
			! !

EmployeeTransaction subclass: #Timecard
	instanceVariableNames: 'hoursWorked hoursVacation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!Timecard commentStamp: '<historical>' prior: 0!
Transaction representing the work that the employee has done.!

!Timecard methodsFor: 'initialize-release' stamp: ''!
date: aDate employee: anEmployee worked: hoursW vacation: hoursV
	date := aDate.
	employee := anEmployee.
	hoursWorked := hoursW.
	hoursVacation := hoursV
			! !

!Timecard methodsFor: 'accessing' stamp: ''!
hoursVacation
	^hoursVacation
			! !

!Timecard methodsFor: 'accessing' stamp: ''!
hoursWorked
	^hoursWorked
			! !

!Timecard methodsFor: 'posting' stamp: 'HenryDuwe 6/20/2013 15:31'!
postTo: anEmployee 
	| money overtime nonovertime |
	overtime := hoursWorked - 40 max: 0.
	nonovertime := hoursWorked min: 40.
	money := overtime * 1.5 + nonovertime * (anEmployee salaryAt: date).
	anEmployee incrementEarned: money at: date.
			! !

Object subclass: #HW2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-HW2'!

!HW2 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 11:17'!
asLowerCase: aString
	|retString|
	retString :=	aString collect: [:each | (each isUppercase) ifTrue:[each asLowercase] ifFalse:[each]].
	^ retString.! !

!HW2 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 11:03'!
capitalLetters: aString
	|retSet retString|
	retSet := Set new.
	retString := ''.
	aString do: [:each | (each isUppercase) ifTrue: [retSet add: each]].
	retSet do: [:each | retString,(each asString)].
	^ retSet.! !

!HW2 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 10:42'!
capitals: aString
	|retString|
	retString := ''.
	aString do: [:each | (each isUppercase) ifTrue: [retString := retString,(each asString)]].
	^ retString.! !

!HW2 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 11:31'!
encode: aString
	|retString|
	retString := aString collect: [:each | (each isLetter) ifTrue:[(each = $Z) 
			ifTrue:[Character value: (each asInteger -25)] 
			ifFalse:[(each = $z) ifTrue:[Character value: (each asInteger -25)] ifFalse:[Character value: (each asInteger +1)]]] ifFalse:[each]].
	^ retString.! !

!HW2 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 10:58'!
reverse: aCollection
	|retColl|
	retColl := aCollection class new.
	aCollection reverseDo: [:each | retColl := retColl copyWith: each].
	^ retColl.! !

!HW2 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/7/2013 11:47'!
wordValue: aWord
	|retNumber|
	retNumber := 0.
	retNumber := aWord inject: retNumber into: [:subTotal :next | subTotal + ((next asLowercase) asInteger - 96)].
	^ retNumber.! !

Object subclass: #PayrollSystem
	instanceVariableNames: 'employees paychecks companyName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!PayrollSystem commentStamp: '<historical>' prior: 0!
I am the top-level of the payroll system.  I keep track of the employees
and can "run the payroll", i.e. write paychecks for the employees.  To
run the payroll, send the messages
	makePaychecksAt: paydate	- to create the paycheck transactions
	printPaychecksOn: aStream	- to print them out 
	postPaychecks				- to record them in employees

Note that the employees are not marked with having been paid until
the paychecks are posted, so just creating the transactions or even
printing them is not enough.

Variables
	employees   <Dictionary from String to Employee>
	paychecks 	<Collection of Paycheck>	holds paychecks that have been created until they have been posted!

!PayrollSystem class methodsFor: 'instance creation' stamp: ''!
new
	^super new initialize
			! !

!PayrollSystem class methodsFor: 'as yet unclassified' stamp: 'Biplab Deka 6/19/2013 14:09'!
readFromFile: aFile
	|rr aPS|
	
	rr := ReferenceStream on: (FileStream fileNamed: aFile).
	rr byteStream setFileTypeToObject.

	aPS := rr next.
	rr close.
	^ aPS.! !

!PayrollSystem methodsFor: 'accessing' stamp: ''!
addEmployee: anEmployee
	employees at: anEmployee name put: anEmployee
			! !

!PayrollSystem methodsFor: 'accessing' stamp: ''!
employeeNamed: aName
	^employees at: aName
			! !

!PayrollSystem methodsFor: 'accessing' stamp: ''!
employeeNames
	^employees keys asOrderedCollection
			! !

!PayrollSystem methodsFor: 'initialize-release' stamp: ''!
initialize
	employees := Dictionary new.
			! !

!PayrollSystem methodsFor: 'actions' stamp: ''!
makePaychecksAt: aDate 
	paychecks := employees collect: [:eachEmployee | eachEmployee makePaycheckAt: aDate]
			! !

!PayrollSystem methodsFor: 'accessing' stamp: ''!
name
	^companyName
			! !

!PayrollSystem methodsFor: 'accessing' stamp: ''!
name: aString
	companyName := aString
			! !

!PayrollSystem methodsFor: 'actions' stamp: ''!
paycheckString
	| aStream |
	aStream := WriteStream on: (String new: 20).
	self printPaychecksOn: aStream.
	^aStream contents
			! !

!PayrollSystem methodsFor: 'actions' stamp: ''!
postPaychecks
	paychecks do: [:each | each post].
	paychecks := #()
			! !

!PayrollSystem methodsFor: 'actions' stamp: ''!
printPaychecksOn: aStream 
	paychecks do: [:each | each printOnCheckStream: aStream]
			! !

!PayrollSystem methodsFor: 'as yet unclassified' stamp: 'Biplab Deka 6/19/2013 13:59'!
writeToFile: aFile
	|rr|
	
	rr := ReferenceStream on: (FileStream fileNamed: aFile).
	rr byteStream setFileTypeToObject.
		
	rr nextPut: self.

	rr close.! !

Object subclass: #TaxRule
	instanceVariableNames: 'breakPoints rates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Payroll'!

!TaxRule commentStamp: '<historical>' prior: 0!
I represent a tax table.  Given a yearly taxable income, I can give the tax rate for it.
I store the tax table as a sequence of amounts, and the tax rate for that amount.
For example, in 1994 the tax rate for a single person (schedule X) was
           $0		15%
  $22750	28%
  $55100	31%
$115000	36%
$250000	39.6%

breakpoints  	<SortedCollection of: integer>
rates	 	<OrderedCollection of: integer>!

!TaxRule class methodsFor: 'instance creation' stamp: ''!
new
	^super new initialize
			! !

!TaxRule methodsFor: 'accessing' stamp: ''!
breakPoint: aNumber rate: anotherNumber 
	"Add an entry to the tax table"

	| index |
	index := breakPoints indexOfStartOfIntervalContaining: aNumber.
	breakPoints add: aNumber.
	rates add: anotherNumber beforeIndex: index + 1
			! !

!TaxRule methodsFor: 'initialize-release' stamp: ''!
initialize
	breakPoints := SortedSequence new.
	rates := OrderedCollection new.
			! !

!TaxRule methodsFor: 'accessing' stamp: ''!
rateFor: aNumber 
	"Return the tax rate for someone whose taxable income is 
	aNumber dollars."

	^rates at: (breakPoints indexOfStartOfIntervalContaining: aNumber)
			! !

Object subclass: #Units
	instanceVariableNames: 'unitsDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-HW3'!

!Units class methodsFor: 'instance creation' stamp: 'HenryDuwe 6/12/2013 15:29'!
newDenominatorUnit: aSymbol
	^self new initialize subtraction: aSymbol.! !

!Units class methodsFor: 'instance creation' stamp: 'HenryDuwe 6/12/2013 15:29'!
newNumeratorUnit: aSymbol
	^self new initialize addition: aSymbol.! !

!Units class methodsFor: 'instance creation' stamp: 'HenryDuwe 6/12/2013 08:12'!
newUnitless
	^self new initialize.! !

!Units methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/12/2013 16:52'!
* aUnits
	|newUnits numerator denominator|
	newUnits := Units newUnitless.
	numerator := self unitsDict select: [:each | each > 0 ].
	denominator := self unitsDict select: [:each | each < 0 ].
	numerator associationsDo: [:each | newUnits addition: each key].
	denominator associationsDo: [:each | newUnits subtraction: each key].
	numerator := aUnits unitsDict select: [:each | each > 0 ].
	denominator := aUnits unitsDict select: [:each | each < 0 ].
	numerator associationsDo: [:each | newUnits addition: each key].
	denominator associationsDo: [:each | newUnits subtraction: each key].
	^ newUnits.! !

!Units methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/12/2013 16:00'!
/ aUnits
	|newUnits numerator denominator|
	newUnits := Units newUnitless.
	numerator := self unitsDict select: [:each | each > 0 ].
	denominator := self unitsDict select: [:each | each < 0 ].
	numerator associationsDo: [:each | newUnits addition: each key].
	denominator associationsDo: [:each | newUnits subtraction: each key].
	numerator := aUnits unitsDict select: [:each | each < 0 ].
	denominator := aUnits unitsDict select: [:each | each > 0 ].
	numerator associationsDo: [:each | newUnits addition: each key].
	denominator associationsDo: [:each | newUnits subtraction: each key].
	^ newUnits.! !

!Units methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/12/2013 07:59'!
= aUnit
	^unitsDict = aUnit unitsDict.
! !

!Units methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/12/2013 14:25'!
addition: aSymbol
	|tmpVal|
	tmpVal := unitsDict removeKey: aSymbol ifAbsent: [0].
	tmpVal := tmpVal + 1.
	unitsDict add: (Association key: aSymbol value: tmpVal).! !

!Units methodsFor: 'initialize-release' stamp: 'HenryDuwe 6/12/2013 07:35'!
initialize
	unitsDict := Dictionary new.
	^ self.! !

!Units methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/12/2013 16:04'!
printOn: aStream
	aStream nextPut: $(.
	(unitsDict size = 0) ifTrue:[.].
	unitsDict associationsDo: [:each | (each value = 0) ifFalse:[each key printOn: aStream. aStream nextPut: $^. each value printOn: aStream. aStream nextPut: $*] ifTrue:[.]].
   aStream nextPut: $).! !

!Units methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/12/2013 14:25'!
subtraction: aSymbol
	|tmpVal|
	tmpVal := unitsDict removeKey: aSymbol ifAbsent: [0].
	tmpVal := tmpVal - 1.
	unitsDict add: (Association key: aSymbol value: tmpVal).! !

!Units methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 6/12/2013 07:59'!
unitsDict 
	^ unitsDict.! !

Object subclass: #ValueWithHistory
	instanceVariableNames: 'date value'
	classVariableNames: 'EarliestDate'
	poolDictionaries: ''
	category: 'CS528su13-ValueWithHistory'!

!ValueWithHistory commentStamp: 'm3r 6/27/2008 01:58' prior: 0!
I represent a (probably numerical) value that changes over time.  I can answer my value at any point in
time (usually a date).  I can update my value at any point in time, and also add a number to my
value from any point in time on into the future.  My value does not change continuously, but changes
at discrete points in time.

Instance Variables:
	date	<SortedCollection of: Date>
	value	<OrderedCollection of: Number>
	The i'th element of value matches the i'th element of date.  The date collection indicates when the value takes on the next element of the value collection.
!

!ValueWithHistory class methodsFor: 'class initialization' stamp: 'm3r 6/27/2008 02:05'!
initialize
	"self initialize"
	EarliestDate := Date newDay: 0 year: 0.
! !

!ValueWithHistory class methodsFor: 'instance creation' stamp: 'm3r 6/27/2008 02:06'!
new
	^ super new initialize
! !

!ValueWithHistory class methodsFor: 'instance creation' stamp: 'm3r 6/27/2008 02:06'!
zero
	^ self new starting: EarliestDate become: 0
! !

!ValueWithHistory methodsFor: 'accessing' stamp: 'm3r 6/27/2008 01:58'!
at: aDate 
	"Return value at aDate"
	| index |
	index := date indexOfStartOfIntervalContaining: aDate.
	index = 0 ifTrue: [self error: 'date is too early'].
	^value at: index
! !

!ValueWithHistory methodsFor: 'accessing' stamp: 'm3r 6/27/2008 01:59'!
at: aDate add: amount 
"Add amount to the value starting at aDate."
	| start |
	start := self indexForAccessing: aDate.
	start to: value size do:
		[:each | value at: each put: (value at: each) + amount].
! !

!ValueWithHistory methodsFor: 'accessing' stamp: 'm3r 6/27/2008 02:00'!
indexForAccessing: aDate 
	"Create index of slot for aDate, creating it if necessary."
	| index |
	(index := date indexOfStartOfIntervalContaining: aDate) = 0 ifTrue: 
		[date add: aDate.
		value addFirst: 0.
		^ 1].
	(date at: index) = aDate ifTrue: [^index].
	date add: aDate.
	value add: (value at: index) beforeIndex: index + 1.
	^ index + 1
! !

!ValueWithHistory methodsFor: 'initialize-release' stamp: 'ChaseGeigle 6/15/2013 23:01'!
initialize
	date := SortedSequence new.
	value := OrderedCollection new.
! !

!ValueWithHistory methodsFor: 'printing' stamp: 'HenryDuwe 6/20/2013 17:02'!
printOn: aStream 
	date with: value do: 
		[: nextDate : nextValue | 
		aStream 
			print: nextDate;
			nextPutAll: ': ';
			print: nextValue;
			nextPutAll: ' ';
			cr].
! !

!ValueWithHistory methodsFor: 'accessing' stamp: 'm3r 6/27/2008 02:00'!
starting: aDate become: anAmount 
	| index |
	date add: aDate.
	index := date indexOfStartOfIntervalContaining: aDate.
	value add: anAmount beforeIndex: index.
! !
Employee initialize!
Paycheck initialize!
ValueWithHistory initialize!
